var CookieHelper = {
    create: function(name, value, days) {
        var expires = "";
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            expires = "; expires=" + date.toUTCString();
        }
        document.cookie = name + "=" + value + expires + "; path=/";
    },

    read: function(name) {
        var nameEQ = name + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
        }
        return null;
    },

    erase: function(name) {
        this.create(name, "", -1);
    }
};

function serialize(obj) {
    var str = [];
    for (var p in obj)
        str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
    return str.join("&");
}

function queryHash() {
    var query = window.location.hash.substring(1);
    if (query == '/' || query == '') {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-list.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/category', true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;

                var response = JSON.parse(this.responseText);

                var html = '';

                for (var i = 0; i < response.length; i++) {
                    html += '<tr id="' + response[i]._id + '"><td>' + response[i].name + '</td><td>' + response[i].description + '</td><td><td><div class="pull-right">' +
                        '<a class="btn btn-info pull-left btn-xs ml-10" href="#/category/' + response[i]._id + '/product" role="button">Просмотреть</a>' +
                        '<a class="btn btn-success pull-left btn-xs ml-10" href="#/category/' + response[i]._id + '/update" role="button">Изменить</a>' +
                        '<a class="btn btn-danger pull-left btn-xs ml-10" onclick="categoryDelete(\'' + response[i]._id + '\'); return false;" role="button">Удалить</a></div></td></tr></td>';
                }

                if (!html) {
                    html = "<p>Нет категорий";
                }

                document.getElementById("category-list").innerHTML = html;

                return false;
            };
            xhr.send();
        };
        xhr.send();
    } else if (query == '/auth') {

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/auth.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;
        };
        xhr.send();
    } else if (query == '/logout') {
        CookieHelper.erase('token');
        window.location.hash = '#/auth';
        return;
    } else if (query == '/auth/register') {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/auth-register.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;
        };
        xhr.send();
    } else if (query == '/category/add') {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-add.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;
        };
        xhr.send();
    } else if (query.search('^\/category\/(.*?)\/product\/add$') != -1) {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-product-add.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            var _id = query.match('\/category\/(.*?)\/product\/add');
            _id = _id[1];

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/category/' + _id, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;
                //console.log(this.responseText);

                var response = JSON.parse(this.responseText);

                document.getElementsByTagName('html')[0].setAttribute('data-id', response._id);
                document.getElementById('url-product-list').href = '#/category/' + response._id + '/product';
                document.getElementById('category-name').innerHTML = response.name;

                return false;
            };
            xhr.send();
        };
        xhr.send();
    } else if (query.search('^\/category\/(.*?)\/product\/(.*?)\/update$') != -1) {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-product-update.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            var _id = query.match('^\/category\/(.*?)\/product\/(.*?)\/update$');

            _id = _id[2];

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/product/' + _id, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;

                var response = JSON.parse(this.responseText);

                document.getElementsByTagName('html')[0].setAttribute('data-id', response._id);

                document.getElementById('url-product-list').href = '#/category/' + response.category._id + '/product';

                document.getElementById('category-name').innerHTML = response.name;

                document.getElementById('_id').value = response._id;
                document.getElementById('name').value = response.name;
                document.getElementById('description').innerHTML = response.description;
                document.getElementById('price').value = response.price;

                return false;
            };
            xhr.send();
        };
        xhr.send();
    } else if (query.search('^\/category\/(.*?)\/product\/(.*?)\/show$') != -1) {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-product.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            var _id = query.match('^\/category\/(.*?)\/product\/(.*?)\/show$');

            _id = _id[2];

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/product/' + _id, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;

                var response = JSON.parse(this.responseText);

                document.getElementsByTagName('html')[0].setAttribute('data-id', response._id);

                document.getElementById('url-product-list').href = '#/category/' + response.category._id + '/product';
                document.getElementById('category-name').innerHTML = response.name;
                document.getElementById('name').innerHTML = response.name;
                document.getElementById('description').innerHTML = response.description;
                document.getElementById('price').innerHTML = response.price;

                return false;
            };
            xhr.send();
        };
        xhr.send();
    } else if (query.search('^\/category\/(.*?)\/update$') != -1) {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-update.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            var _id = query.match('\/category\/(.*?)\/update');
            _id = _id[1];

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/category/' + _id, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;

                var response = JSON.parse(this.responseText);

                document.getElementById('_id').value = response._id;
                document.getElementById('name').value = response.name;
                document.getElementById('description').innerHTML = response.description;

                return false;
            };
            xhr.send();
        };
        xhr.send();
    } else if (query.search('^\/category\/(.*?)\/product$') != -1) {
        var token = CookieHelper.read('token');

        if (token === '' || token === null) {
            window.location.hash = '#/auth';
            return;
        }

        var xhr = new XMLHttpRequest();
        xhr.open('GET', './html/category-product-list.html', true);
        xhr.onreadystatechange = function() {
            if (this.readyState !== 4) return;
            if (this.status !== 200) return;

            var _id = query.match('\/category\/(.*?)\/product');
            _id = _id[1];

            document.getElementsByTagName('html')[0].innerHTML = this.responseText;

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://api.volga-it.itech-test.ru/category/' + _id, true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

            xhr.onreadystatechange = function() {
                if (this.readyState !== 4) return;

                var response = JSON.parse(this.responseText);

                document.getElementsByTagName('html')[0].setAttribute('data-id', response._id);
                document.getElementById('add-product').href = '#/category/' + response._id + '/product/add';
                document.getElementById('category-name').innerHTML = response.name;

                showCategoryProducts(_id);

                return false;
            };
            xhr.send();
        };
        xhr.send();

    } else {
        document.getElementsByTagName('html')[0].innerHTML = '404';
    }
}

queryHash();

window.onhashchange = function() {
    queryHash();
}

function auth() {
    var login = document.getElementById('login').value;
    var password = document.getElementById('password').value;
    var errorMessage = '';

    if (login == '') {
        errorMessage += 'Пожалуйста введите имя пользователя\n';
    }

    if (password == '') {
        errorMessage += 'Пожалуйста введите пароль\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('POST', 'http://api.volga-it.itech-test.ru/auth', true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response.success) {
            CookieHelper.create('token', response.token, 1);
            window.location.hash = '#/';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Неверное имя пользователя или пароль';
        }

        return false;
    };
    xhr.send(serialize({
        'login': login,
        'password': password
    }));

    return false;
}

function register() {
    var login = document.getElementById('login').value;
    var password = document.getElementById('password').value;
    var confirmPassword = document.getElementById('confirmPassword').value;

    var errorMessage = '';

    if (login == '') {
        errorMessage += 'Пожалуйста введите имя пользователя\n';
    }

    if (password == '') {
        errorMessage += 'Пожалуйста введите пароль\n';
    }

    if (confirmPassword == '') {
        errorMessage += 'Пожалуйста подтверждение пароля\n';
    }

    if (password != confirmPassword) {
        errorMessage += 'Введенные пароли должны совпадать\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('POST', 'http://api.volga-it.itech-test.ru/auth/register', true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);
        var errorMessage = '';

        if (response.success) {
            CookieHelper.create('token', response.token, 1);
            window.location.hash = '#/';
        } else {
            if (typeof response.error === 'string') {
                if (response.error == 'User validation failed') {
                    errorMessage += 'Не все обязательные поля заполнены\n';
                } else if (response.error == 'Passwords do not match') {
                    errorMessage += 'Пароли не совпадают\n';
                } else {
                    errorMessage += response.error + '\n';
                }
            } else {
                errorMessage += 'Данное имя пользователя уже существует\n';
            }

            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = errorMessage;
        }

        return false;
    };

    xhr.send(serialize({
        'login': login,
        'password': password,
        'confirmPassword': confirmPassword
    }));

    return false;
}

function categoryAdd() {
    var name = document.getElementById('name').value;
    var description = document.getElementById('description').value;
    var errorMessage = '';

    if (name == '') {
        errorMessage += 'Пожалуйста введите имя категории\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('POST', 'http://api.volga-it.itech-test.ru/category', true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);
        if (response._id) {
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Категория добавлена';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Вы не ввели имя категории';
        }

        return false;
    };
    xhr.send(serialize({
        'name': name,
        'description': description
    }));

    return false;
}

function categoryUpdate() {
    var _id = document.getElementById('_id').value;
    var name = document.getElementById('name').value;
    var description = document.getElementById('description').value;
    var errorMessage = '';

    if (name == '') {
        errorMessage += 'Пожалуйста введите имя категории\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('PUT', 'http://api.volga-it.itech-test.ru/category/' + _id, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response.success) {
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Категория изменена';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Вы не ввели имя категории';
        }

        return false;
    };
    xhr.send(serialize({
        'name': name,
        'description': description,
        'Id': _id
    }));

    return false;
}

function categoryDelete(_id) {
    var xhr = new XMLHttpRequest();
    xhr.open('DELETE', 'http://api.volga-it.itech-test.ru/category/' + _id, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response.success) {
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Категория удалена';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Произошла ошибка, возможно категория была уже удалена';
        }

        var el = document.getElementById(_id);
        el.parentNode.removeChild(el);

        return false;
    };
    xhr.send(serialize({
        'Id': _id
    }));

    return false;
}

function showCategoryProducts(_id, q, priceFrom, priceTo) {
    var url = 'http://api.volga-it.itech-test.ru/product?category=' + _id;

    if (typeof q !== 'undefined' && q.length > 0) {
        url += '&q=' + q;
    }

    if (typeof priceFrom !== 'undefined' && priceFrom.length > 0) {
        url += '&price_from=' + priceFrom;
    }

    if (typeof priceTo !== 'undefined' && priceTo.length > 0) {
        url += '&price_to=' + priceTo;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        var html = '';

        for (var i = 0; i < response.length; i++) {
            html +=
                '<div class="col-xs-12 col-sm-6 col-md-3 mb-40" id="' + response[i]._id + '">' +
                '  <div class="col-item">' +
                '      <div class="photo">' +
                '          <a href="#/category/' + response[i].category._id + '/product/' + response[i]._id + '/show"><img src="http://placehold.it/350x260" class="img-responsive" alt="a" /></a>' +
                '      </div>' +
                '      <div class="info">' +
                '          <div class="row">' +
                '              <div class="price col-md-12">' +
                '                  <h5>' + response[i].name + '</h5>' +
                '                  <h5 class="price-text-color">' + response[i].price + '</h5>' +
                '              </div>' +
                '          </div>' +
                '          <div class="row">' +
                '              <div class="price col-md-6">' +
                '                  <a class="btn btn-success pull-right" href="#/category/' + response[i].category._id + '/product/' + response[i]._id + '/update" role="button">Изменить</a>' +
                '              </div>' +
                '              <div class="price col-md-6">' +
                '                  <a class="btn btn-danger pull-left" onclick="productDelete(\'' + response[i]._id + '\'); return false;" role="button">Удалить</a></div></td></tr></td>' +
                '              </div>' +
                '          </div>' +
                '          <div class="clearfix"></div>' +
                '      </div>' +
                '  </div>' +
                '</div>';
        }

        if (!html) {
            html = "<p>Нет товаров"
        }

        document.getElementById("product-list").innerHTML = html;

        return false;
    };
    xhr.send();
}

function productAdd() {
    var name = document.getElementById('name').value;
    var description = document.getElementById('description').value;
    var price = document.getElementById('price').value;
    var errorMessage = '';

    if (name == '') {
        errorMessage += 'Пожалуйста введите имя продукта\n';
    }

    if (price == '') {
        errorMessage += 'Пожалуйста введите корректно цену\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var _id = document.getElementsByTagName('html')[0].getAttribute('data-id');
    var xhr = new XMLHttpRequest();
    xhr.open('POST', 'http://api.volga-it.itech-test.ru/product', true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response._id) {
            document.getElementById('error-message').classList.add('hidden');
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Товар добавлен';
        } else {
            document.getElementById('success-message').classList.add('hidden');
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Вы не ввели обязательные поля';
        }

        return false;
    };
    xhr.send(serialize({
        'name': name,
        'description': description,
        'price': price,
        'category': _id
    }));

    return false;
}

function productUpdate() {
    var _id = document.getElementById('_id').value;
    var name = document.getElementById('name').value;
    var price = document.getElementById('price').value;
    var description = document.getElementById('description').value;
    var errorMessage = '';

    if (name == '') {
        errorMessage += 'Пожалуйста введите имя продукта\n';
    }

    if (!isNaN(price) && price.toString().indexOf('.') != -1) {
        errorMessage += 'Пожалуйста введите корректно цену\n';
    }

    if (errorMessage.length) {
        document.getElementById('error-message').classList.remove('hidden');
        document.getElementById('error-message').innerHTML = errorMessage;
        return false;
    }

    var xhr = new XMLHttpRequest();
    xhr.open('PUT', 'http://api.volga-it.itech-test.ru/product/' + _id, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response.success) {
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Категория добавлена';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Вы не ввели имя категории';
        }

        return false;
    };
    xhr.send(serialize({
        'name': name,
        'description': description,
        'price': price,
        'category': _id
    }));

    return false;
}


function productDelete(_id) {
    var xhr = new XMLHttpRequest();
    xhr.open('DELETE', 'http://api.volga-it.itech-test.ru/product/' + _id, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.setRequestHeader('x-access-token', CookieHelper.read('token'));

    xhr.onreadystatechange = function() {
        if (this.readyState !== 4) return;

        var response = JSON.parse(this.responseText);

        if (response.success) {
            document.getElementById('success-message').classList.remove('hidden');
            document.getElementById('success-message').innerHTML = 'Продукт удален';
        } else {
            document.getElementById('error-message').classList.remove('hidden');
            document.getElementById('error-message').innerHTML = 'Произошла ошибка, возможно продукт был уже удален';
        }

        var el = document.getElementById(_id);
        el.parentNode.removeChild(el);

        return false;
    };
    xhr.send(serialize({
        'Id': _id
    }));

    return false;
}

function onFilterChange() {
    var _id = document.getElementsByTagName('html')[0].getAttribute('data-id');
    var q = document.getElementById('q').value;
    var priceFrom = document.getElementById('price_from').value;
    var priceTo = document.getElementById('price_to').value;

    showCategoryProducts(_id, q, priceFrom, priceTo);
}